//getChannel
function getChannel () {
  var url = document.getElementById('channelUrl').value;
  addChannel(url);
}


// addChannel
function addChannel (aurl) {
  if (aurl.length > 0) {
    channelUrl = aurl;
  } else {
    channelUrl = 'http://';
  }
  
  loader();
  
  // je url k dispozici
  monitorUrl(channelUrl);
}  

// URLMonitor
function monitorUrl (aurl) {
  var urlReq = new air.URLRequest(aurl);
  var monitor = new air.URLMonitor(urlReq);
  monitor.addEventListener(air.StatusEvent.STATUS, statusChange);
  monitor.start();
}  

// handler pro URLmonitor (pokud je url k dispozici prove xhr na dane url, jinak)
function statusChange (e) {
  if (e.target.available) {
    air.trace('URL available: '+ e.target.available);
    makeXMLRequest(channelUrl, populateChannel);
  } else {
    air.trace('URL available: '+ e.target.available);
    
    insertNPChannel.text = 'INSERT INTO channel (title, feed_url, parsed) VALUES (?, ?, ?)';
    insertNPChannel.parameters[0] = channelUrl;
    insertNPChannel.parameters[1] = channelUrl;
    insertNPChannel.parameters[2] = 0;
    insertNPChannel.execute();
  }
}
  

// makeXMLRequest
function makeXMLRequest (aurl, ahandler) {
  var xhr = new XMLHttpRequest();
  
  xhr.open('get', aurl);
	xhr.onreadystatechange = ahandler;
	xhr.send(null);
}


// populateChannel handler pro xhr
function populateChannel(e) {
 if (e.target.readyState == 4) {
   air.trace(e.target.getAllResponseHeaders());
   if (e.target.responseXML != null) {
     air.trace('responseXML')
     xml = e.target.responseXML;       
     doInsChannel();
   } else if (e.target.responseText != null) {
     air.trace('responseText')
     var data = e.target.responseText;
     air.trace(data);
     var dp = new DOMParser();
     // data ve formatu XML
     xml = dp.parseFromString(data, 'text/xml');
     doInsChannel();
   } else {
     air.trace('feed_url error');
     document.getElementById('channelUrl').value = null;
     loader();
   }   
 }
}


function doInsChannel () {
  xmlToArrayChannel();
  var feed_url = channelUrl;
  
  insertChannel.text = 'INSERT INTO channel (title, link, description, language, copyright, managingEditor, webMaster, pubDate, lastBuildDate, category, generator, docs, ttl, rating, textInput, skipHours, skipDays, feed_url, parsed) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)'; 
  insertChannel.parameters[0] = channel[0];	
  insertChannel.parameters[1] = channel[1];
  insertChannel.parameters[2] = channel[2];
  insertChannel.parameters[3] = channel[3];
  insertChannel.parameters[4] = channel[4];
  insertChannel.parameters[5] = channel[5];
  insertChannel.parameters[6] = channel[6];
  insertChannel.parameters[7] = channel[7];
  insertChannel.parameters[8] = channel[8];
  insertChannel.parameters[9] = channel[9];
  insertChannel.parameters[10] = channel[10];
  insertChannel.parameters[11] = channel[11];
  insertChannel.parameters[12] = channel[12];
  insertChannel.parameters[13] = channel[13];
  insertChannel.parameters[14] = channel[14];
  insertChannel.parameters[15] = channel[15];
  insertChannel.parameters[16] = channel[16];
  insertChannel.parameters[17] = feed_url;
  insertChannel.parameters[18] = 1;
  insertChannel.execute();
}

function doInsItem (acindex) {    
  if (!itemInserted) {
    itemInserted = true;
    // v pripade ze se neprovadi update items ale pouze pridani kanalu
    if (!updatingItems) {
      itemCount = xml.querySelectorAll('item').length;
    }    
  }
  
  if (itemIndex < itemCount) {
    xmlToArrayItem(itemCols, item, acindex);
    
    insertItem.text = 'INSERT INTO item (title, link, description, author, category, comments, guid, pubDate, source, channel_id) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)';        
    insertItem.parameters[0] = item[0];	
    insertItem.parameters[1] = item[1];
    insertItem.parameters[2] = item[2];
    insertItem.parameters[3] = item[3];
    insertItem.parameters[4] = item[4];
    insertItem.parameters[5] = item[5];
    insertItem.parameters[6] = item[6];
    insertItem.parameters[7] = item[7];
    insertItem.parameters[8] = item[8];
    insertItem.parameters[9] = insRowId;      

    itemIndex++;      
    insertItem.execute();

  } else {
    // vsechny items jsou vlozeny => je potreba vynulovat pomocne promenne
    itemInserted = false;    
    itemIndex = 0;
    itemCount = 0;
    
    air.trace('There are no other item\'s data in XML!');
    
    // promenne pouzite pri updatu items
    updatingItems = false;
    refrChannelID = 0
    
    nullArray(guidFromXml);
    nullArray(guidFromDb);
    nullArray(guidIndex);
    
    selChannel();
    fireClickEvent('#feed-list', '.active');
    loader();
  }
}


// naplneni pole 'channel' daty z XML
function xmlToArrayChannel () {
  for (var i = 0; i < channelCols.length; i++) {
    if (xml.querySelector('channel > ' + channelCols[i]) != null) {
      var tag = xml.querySelector('channel > ' + channelCols[i]);
      
      if (tag.lastChild != null) {
        if (tag.lastChild.nodeValue != null) {
          channel[i] = tag.lastChild.nodeValue;
        } else {
          channel[i] = channelCols[i];
        }
      } else {
        channel[i] = channelCols[i];
      }
    } else {
      channel[i] = channelCols[i];
    }
  }
}  


// // naplneni pole 'item' daty z XML (i-te polozky)
// function xmlToArrayItem (acols, adata, aindex) {
//   var items = xml.querySelectorAll('item');
//   for (var j = 0; j < acols.length; j++) {      
//     if (items[aindex].querySelector(acols[j]) != null) {
//       if (items[aindex].querySelector(acols[j]).lastChild != null) {
//         if (items[aindex].querySelector(acols[j]).lastChild.nodeValue != null) {
//           adata[j] = items[aindex].querySelector(acols[j]).lastChild.nodeValue;
//         } else {
//           adata[j] = acols[j];
//         }
//       } else {
//         adata[j] = acols[j];
//       }
//     } else {
//       adata[j] = acols[j];
//     }           
//   }
// }


// naplneni pole 'item' daty z XML (i-te polozky)
function xmlToArrayItem (acols, adata, aindex) {
  var items = xml.querySelectorAll('item');    
  for (var j = 0; j < acols.length; j++) {      
    if (items[aindex].querySelector(acols[j]) != null) {
      if (items[aindex].querySelector(acols[j]).childNodes != null) {
        var children = items[aindex].querySelector(acols[j]).childNodes;
        var nodes = '';
        for (var i = 0; i < children.length; i++) {
          if (children[i].nodeType == 1 || children[i].nodeType == 3 || children[i].nodeType == 4 || children[i].nodeType == 5 || children[i].nodeType == 6) {
            nodes += children[i].nodeValue;
          }
        }
        
        // prevod data na vhodny format
        if (acols[j] == 'pubDate'){
          nodes = parseDate(nodes);
        }
        
        adata[j] = nodes;
        
      } else {
        adata[j] = acols[j];
      }
    } else {
      adata[j] = acols[j];
    }           
  }
}


function insertChannelResult (e) {
  // nastaveni globalni promenne (ID vlozeneho kanalu)
  var results = e.target.getResult();    
  insRowId = results.lastInsertRowID;
  
  air.trace('inserted channel\'s row ID: ' + insRowId);
  
  nullArray(channel);
  document.getElementById('channelUrl').value = null;
  channelUrl = null;
  
  // musi se volat tady (prace s db je asynchronni => nejde provadet dalsi operace s db dokud neskonci jina operace; navazujici operace se provest muzou => pridaji se do fronty)
  doInsItem(0);
}

function insertChannelNPResult (e) {
  selChannel();
  
  // nastaveni globalni promenne (ID vlozeneho kanalu)
  var results = e.target.getResult();    
  insRowId = results.lastInsertRowID;
  
  air.trace('inserted channel\'s row ID: ' + insRowId);
  
  document.getElementById('channelUrl').value = null;
  channelUrl = null;
  
  loader();
}

function insertItemResult (e) {    
  var results = e.target.getResult();
  air.trace('inserted item\'s row ID: ' + results.lastInsertRowID);
  
  nullArray(item);
  // dalsi volani je jiz s itemIndex++ (vlozeni dalsi polozky z XML); itemIndex - globalni promenna
  if (updatingItems) {
    doInsItem(guidIndex[itemIndex]);
  } else {
    doInsItem(itemIndex);
  }
}




// funkce, ktera handluje ondragstart event
function doDragStart (e) {
  e.dataTransfer.effectAllowed = 'move';
}

// funkce, ktera handluje ondragover event
function doDragOver (e) {
  e.preventDefault();
  e.target.setAttribute('class', 'drag-over');
}

function doDragLeave (e) {
  e.preventDefault();
  e.target.setAttribute('class', 'drag-leave');
}

// funkce, ktera handluje ondrop event
function doDrop (e) {
  e.preventDefault();
  e.target.setAttribute('class', 'drop');
  // reseni ruznych formatu
  var uriList = e.dataTransfer.getData('text/uri-list');
  var plainText =  e.dataTransfer.getData('text/plain');
  
  if (uriList) {
    addChannel(uriList);
  } else if (plainText) {
    addChannel(plainText);
  } else {
    alert('Format not supported.');
  }
  
  e.target.removeAttribute('class');
}