var channelId = new Array();
var itemsUnread = new Array();
var channelIdIndex = 0;

// SELECT dat z db potrebnych pro vytvoreni seznamu kanalu
function selChannel () {
  selectChannel.text = 'SELECT id, title, feed_url, parsed FROM channel ORDER BY id DESC';
  selectChannel.execute();
}  

// vygenerovani seznamu feedu
function listChannel (e) {    
  var feedList = document.querySelector('#left #channel #feed-list');
  
  // jestlize seznam uz existuje => smazat ho    
  if (feedList) {
    var activeEl = feedList.querySelector('.active');
    if (activeEl != null) {
      var activeId = activeEl.getAttribute('id');
      
      if (activeEl.nextSibling) {
        var nextId = activeEl.nextSibling.getAttribute('id');
      } else {
        nextId = null;
      }
      
      if (activeEl.previousSibling) {
        var prevId = activeEl.previousSibling.getAttribute('id');
      } else {
        prevId = null;
      }
      
      air.trace('--------------------------------');
      air.trace(prevId);
      air.trace(activeId);
      air.trace(nextId);      
    }
    document.querySelector('#left #channel').removeChild(feedList);
  }
  
  // ziskani vysledku SELECT dotazu
  var results = e.target.getResult();
  
  var ul = document.createElement('ul');
  ul.setAttribute('id', 'feed-list');
  
  if (results.data != null) {      
    // promenne vytvarenych elementu
    var li = null;
    
    // projdeme pole selectovanych dat a vezmeme si, co bude potreba
    for (var i = 0; i < results.data.length; i++) {
      li = document.createElement('li');
      li.setAttribute('id', results.data[i].id);
      li.setAttribute('rel', results.data[i].feed_url);
      if (results.data[i].parsed == 0) {
        li.setAttribute('class', 'not-parsed');        
      } else {
        li.setAttribute('parsed', 'parsed');
      }
            
      li.innerText = results.data[i].title;
      
      li.addEventListener('click', selItem);
      
      ul.appendChild(li);
    }
  } else {
    var li = document.createElement('li');
    li.setAttribute('class', 'default-text')
    li.innerText = 'There are currently no Feeds';
    ul.appendChild(li);
  }
  document.querySelector('#left #channel').appendChild(ul);

  // nastaveni class="active" polozce, ktera byla aktiveni pred rebuildem seznamu
  if (activeId != null) {
    var newLis = document.querySelectorAll('#feed-list li');
    var elFound = false;
    
    for (var i = 0; i < newLis.length; i++) {
      if (newLis[i].getAttribute('id') == activeId) {
        air.trace('Active element found');
        elFound = true;
        break;
      }
    }
    if (!elFound) {
      activeId = null;
    }
  }  
  
  air.trace('----------------');
  air.trace(prevId);
  air.trace(activeId);
  air.trace(nextId);
  air.trace('--------------------------------');
  
  if (activeId != null) {
    setActiveOnId(activeId);
    activeId = null;
  } else if (activeId == null && nextId != null) {
    setActiveOnId(nextId);
    nextId = null;
  } else if (nextId == null && prevId != null) {
    setActiveOnId(prevId);
    prevId = null;
  } else {
      var itemList = document.querySelector('#item-list');
      var itemDataList = document.querySelector('#item-data-list');
      if (itemList) {
        var itemParent = itemList.parentNode;
        itemParent.removeChild(itemList);
      }
      
      if (itemDataList) {
        var dataParent = itemDataList.parentNode;
        dataParent.removeChild(itemDataList);
      }
  }
  
  if (deleting) {
    fireClickEvent('#feed-list', '.active');
    deleting = false;
  }
  
  getChannelIds();
}


// naplni pole channelId hodnotami ID z feef-list seznamu
function getChannelIds () {
  nullArray(channelId);
  nullArray(itemsUnread);
  channelIdIndex = 0;
  
  var feedList = document.querySelector('#feed-list');
  
  if (feedList) {
    var lis = feedList.querySelectorAll('li');
    for (var i = 0; i < lis.length; i++) {
      var parsed = lis[i].getAttribute('parsed');
      if (parsed != null) {
        // pokud narazime pri prochazeni pole na kanal s atributem 'parsed', vlozime jeho ID na konec pole
        channelId.push(lis[i].getAttribute('id'));
      }      
    }
    
    // pokud jsou v seznamu kanaly, ktere jsou parsed (je moznost, ze obsahuji nejake items)
    if (channelId.length > 0) {
      // prvni kanal s atributem 'parsed' - SELECT vsech neprectenych polozek
      selUnread(channelId[channelIdIndex]);
    } else {
      air.trace('There is no parsed channel.');
    }
  }
}


// zjisteni poctu neprectenych polozek daneho kanalu
function selUnread (achannelid) {  
  selectItemCount.text = 'SELECT id FROM item WHERE channel_id=' + achannelid + ' AND read=0';
  selectItemCount.execute();
}

// naplni pole itemsUnread poctem neprectenych polozek
function updateCounts (e) {
  var results = e.target.getResult();
  
  if (results.data != null) {
    var count = results.data.length;
    itemsUnread.push(count);
  } else {
    itemsUnread.push(0);
  }
  
  channelIdIndex++;
    
  if (channelIdIndex < channelId.length) {    
    selUnread(channelId[channelIdIndex]);
  } else {
    // obe pole jsou naplnena (channelId, itemsUnread), muzou se tedy proji a updatovat seznam o pocet neprectenych polozek
    
    // for (var i = 0; i < channelId.length; i++){
    //   air.trace('channel ID: ' + channelId[i]);
    // }
    // for (var i = 0; i < itemsUnread.length; i++){
    //   air.trace('items unread: ' + itemsUnread[i]);
    // }
    
    var feedList = document.querySelector('#feed-list');
    var lis = feedList.querySelectorAll('li');
    var em = null;
    
    for (var i = 0; i < lis.length; i++) {
      var id = lis[i].getAttribute('id');
      // vrati index v danem poli, jinak vraci false
      var index = getIndex(channelId, id);
      // air.trace('index id: ' + id + ' v poli je: ' + index);
      
      if (index != -1 && itemsUnread[index] > 0) {
        em = document.createElement('em');
        em.innerText = itemsUnread[index];
        lis[i].appendChild(em);
      }        
    }
  }  
}

// vraci index v poli, na jehoz miste je dana hodnota
function getIndex (aarray, avalue) {
  var result = 0;
  for (var i = 0; i < aarray.length; i++) {
    if (aarray[i] == avalue) {
      result = i;
      break;
    } else {
      result = -1;
    }
  }
  return result;
}