// definice vlastniho nativniho menu
function defineMenu () {
  // vytvoreni korenoveho menu
  var rootMenu = new air.NativeMenu();

  // vytvoreni submenu (soubor)
  var fileMenu = new air.NativeMenu();
  fileMenu.addEventListener(air.Event.SELECT, changeFile);
  			
  // vytvoreni polozky submenu 'soubor' a jeji pridani do submenu
  var subscribe = new air.NativeMenuItem('Subscribe');
  fileMenu.addItem(subscribe);
  var unsubscribe = new air.NativeMenuItem('Unsubscribe');
  fileMenu.addItem(unsubscribe);
  var separator = new air.NativeMenuItem('', true);
  fileMenu.addItem(separator);
  var exit = new air.NativeMenuItem('Exit');
  fileMenu.addItem(exit);


  // vytvoreni submenu (zobrazit)
  var viewMenu = new air.NativeMenu();	
  viewMenu.addEventListener(air.Event.SELECT, changeView);
  
  // vytvoreni polozky submenu 'zobrazit' a jeji pridani do submenu
  var dropZone = new air.NativeMenuItem('Drop Url');
  viewMenu.addItem(dropZone);
  var separator = new air.NativeMenuItem('', true);
  viewMenu.addItem(separator);
  var resDef = new air.NativeMenuItem('Default Resolution');			
  viewMenu.addItem(resDef);
  var resOne = new air.NativeMenuItem('1280x800');			
  viewMenu.addItem(resOne);
  var resTwo = new air.NativeMenuItem('1600x1000');			
  viewMenu.addItem(resTwo);
  var separator = new air.NativeMenuItem('', true);
  viewMenu.addItem(separator);
  var fullScreen = new air.NativeMenuItem('Full Screen');			
  viewMenu.addItem(fullScreen);
  

  // vytvoreni submenu (novinky)
  var newsMenu = new air.NativeMenu();
  newsMenu.addEventListener(air.Event.SELECT, changeNews);
  
  // vytvoreni polozky submenu 'novinky' a jeji pridani do submenu
  var refresh = new air.NativeMenuItem('Refresh');			
  newsMenu.addItem(refresh);
  var separator = new air.NativeMenuItem('', true);
  newsMenu.addItem(separator);
  var markUnread = new air.NativeMenuItem('Mark As Unread');			
  newsMenu.addItem(markUnread);
  var markAllRead = new air.NativeMenuItem('Mark All As Read');			
  newsMenu.addItem(markAllRead);
  var markAllUnread = new air.NativeMenuItem('Mark All As Unread');			
  newsMenu.addItem(markAllUnread);
  var separator = new air.NativeMenuItem('', true);
  newsMenu.addItem(separator);
  var deleteNews = new air.NativeMenuItem('Delete News');			
  newsMenu.addItem(deleteNews);
  

  // vytvoreni submenu (napoveda)
  var helpMenu = new air.NativeMenu();
  		
  // vytvoreni polozek submenu 'napoveda' a jijich pridani do submenu
  var about = new air.NativeMenuItem('About');
  about.addEventListener(air.Event.SELECT, showAbout);
  helpMenu.addItem(about);

  // pridani submenu do korenove menu
  rootMenu.addSubmenu(fileMenu, 'File');
  rootMenu.addSubmenu(viewMenu, 'View');
  rootMenu.addSubmenu(newsMenu, 'News');  
  rootMenu.addSubmenu(helpMenu, 'Help');

  // pridani korenoveho menu do programu
  if (air.NativeWindow.supportsMenu) { // Windows

  	// pridani klavesovych zkratek
    subscribe.keyEquivalent = 'n';
    subscribe.keyEquivalentModifiers = [air.Keyboard.CONTROL];
    
  	exit.keyEquivalent = 'f4';
  	exit.keyEquivalentModifiers = [air.Keyboard.ALTERNATE];

  	window.nativeWindow.menu = rootMenu; // menu okna
    // window.nativeWindow.icon.menu = rootMenu; // system tray

  } else if (air.NativeApplication.supportsMenu) { // Mac OS X
    subscribe.keyEquivalent = 'n';
    subscribe.keyEquivalentModifiers = [air.Keyboard.COMMAND];
    
  	exit.keyEquivalent = 'q';
  	exit.keyEquivalentModifiers = [air.Keyboard.COMMAND];

  	exit.label = 'Quit';
  	air.NativeApplication.nativeApplication.menu = rootMenu; // menu aplikace
  	air.NativeApplication.nativeApplication.icon.menu = rootMenu; // dock
  }
}