var refrUrl = null;
var refrChannelID = 0;

function refreshChannel () {
  var actChannel = document.querySelector('#feed-list .active');
  
  if (actChannel) {
    refrUrl = actChannel.getAttribute('rel');
    refrChannelID = actChannel.getAttribute('id');
    
    loader();
    
    var parsed = actChannel.getAttribute('parsed');   
    if (!parsed) {
      monitorRefreshedUrl(refrUrl, notParsedStChange);
    } else {
      monitorRefreshedUrl(refrUrl, parsedStChange);
    }
  }
}


// URLMonitor
function monitorRefreshedUrl (aurl, ahandler) {
  var urlReq = new air.URLRequest(aurl);
  var monitor = new air.URLMonitor(urlReq);
  monitor.addEventListener(air.StatusEvent.STATUS, ahandler);
  monitor.start();
}


// handler pro URLmonitor (v pripade, ze je URL k dispozici, provede se neparsovaneho kanalu update kanalu)
function notParsedStChange (e) {
  if (e.target.available) {
    air.trace('URL available: '+ e.target.available);
    makeXMLRequest(refrUrl, updChannel);
  } else {
    air.trace('URL available: '+ e.target.available);
    loader();
  }
}


// updChannel - handler pro xhr (v pripade neparsovaneho kanalu)
function updChannel(e) {
	if (e.target.readyState == 4) {
	  if (e.target.responseXML != null) {
	    xml = e.target.responseXML;		    
	    doUpdChannel();
	  } else {
      air.trace('feed_url error');
      loader();
	  }		
	}
}


// slouzi k updatu neparsovaneho kanalu (v pripade, ze je dane URL k dispozici)
function doUpdChannel () {
  xmlToArrayChannel();
  
  // updateChannel.text = 'UPDATE channel SET title=' + '\'' + channel[0] + '\'' + ', link=' + '\'' + channel[1] + '\'' + ', description=' + channel[2];
  // updateChannel.text +=', language=' + channel[3] + ', copyright=' + channel[4] + ', managingEditor=' + channel[5];
  // updateChannel.text +=', webMaster=' + channel[6] + ', pubDate=' + channel[7] + ', lastBuildDate=' + channel[8];
  // updateChannel.text +=', category=' + channel[9] + ', generator=' + channel[10] + ', docs=' + channel[11];
  // updateChannel.text +=', ttl=' + channel[12] + ', rating=' + channel[13] + ', textInput=' + channel[14];
  // updateChannel.text +=', skipHours=' + channel[15] + ', skipDays=' + channel[16] + ', parsed=1 WHERE id=' + refrChannelID;
  
  updateChannel.text = 'REPLACE INTO channel (title, link, description, language, copyright, managingEditor, webMaster, pubDate, lastBuildDate, category, generator, docs, ttl, rating, textInput, skipHours, skipDays, feed_url, parsed, id) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)'; 
  updateChannel.parameters[0] = channel[0];	
  updateChannel.parameters[1] = channel[1];
  updateChannel.parameters[2] = channel[2];
  updateChannel.parameters[3] = channel[3];
  updateChannel.parameters[4] = channel[4];
  updateChannel.parameters[5] = channel[5];
  updateChannel.parameters[6] = channel[6];
  updateChannel.parameters[7] = channel[7];
  updateChannel.parameters[8] = channel[8];
  updateChannel.parameters[9] = channel[9];
  updateChannel.parameters[10] = channel[10];
  updateChannel.parameters[11] = channel[11];
  updateChannel.parameters[12] = channel[12];
  updateChannel.parameters[13] = channel[13];
  updateChannel.parameters[14] = channel[14];
  updateChannel.parameters[15] = channel[15];
  updateChannel.parameters[16] = channel[16];
  updateChannel.parameters[17] = refrUrl;
  updateChannel.parameters[18] = 1;
  
  updateChannel.parameters[19] = refrChannelID;
  
  updateChannel.execute();
}


// vysledek updatu kanalu (provede se vlozeni i souvisejicich polozek)
function parseItems () {
  insRowId = refrChannelID;
    
  nullArray(channel);
  refrUrl = null;  
  
  doInsItem(0);
}




function parsedStChange (e) {
  if (e.target.available) {
    air.trace('URL available: '+ e.target.available);
    makeXMLRequest(refrUrl, updItemList);
  } else {
    air.trace('URL available: '+ e.target.available);
    loader();
  }
}


// updItemList - handler pro xhr (v pripade neparsovaneho kanalu)
function updItemList(e) {
	if (e.target.readyState == 4) {
	  if (e.target.responseXML != null) {
	    xml = e.target.responseXML;		    
	    doUpdItemList();
	  } else {
      air.trace('feed_url error');
      loader();
	  }		
	}
}


var guidFromXml = new Array();
var guidFromDb = new Array();
var guidIndex = new Array();

function doUpdItemList (argument) {
  nullArray(guidFromXml);
  // 1. naplnime pole 'guidFromXml' => ziskame jednotlive guids z XML
  var guids = xml.querySelectorAll('item guid');
  if (guids.length > 0) {
    for (var i = 0; i < guids.length; i++) {
      var text = guids[i].lastChild.nodeValue;
      if (text) {
        guidFromXml.push(text);
      }
    }
    
  } else {
    var item = xml.querySelectorAll('item');
    for (var i = 0; i < item.length; i++) {
      guidFromXml.push('no guid');
    }
    air.trace('no guids from XML count: ' + item.length);
  }
  air.trace('guids from XML count: ' + guids.length);
  
  // 2. naplnime pole 'guidFromDB (SELECT vsech guids v tabulce item s danym ID kanalu - jeden dotaz => jednou volana funkce, jeden handler)
  selItemGuid(); 
}


// SELECT vsech guid pro dane ID kanalu
function selItemGuid () {
  selectItemGuid.text = 'SELECT guid FROM item WHERE channel_id=' + refrChannelID;
  selectItemGuid.execute();
}

// naplneni pole guidFromDB selectovanymi daty (jednotlive guid)
function getItemGuid (e) {
  var results = e.target.getResult();
  nullArray(guidFromDb);
  nullArray(guidIndex);
  
  if (results.data != null) {
    for (var i = 0; i < results.data.length; i++) {
      guidFromDb.push(results.data[i].guid);
    }    
    
    // 3. porovname postupne nove guids s guids z DB a do pole 'guidIndex' si ulozime indexy novych quids
    for (var i = 0; i < guidFromXml.length; i++) {
      var xmlGuid = guidFromXml[i];

      for (var j = 0; j < guidFromDb.length; j++) {
        var dbGuid = guidFromDb[j];

        if (xmlGuid == dbGuid) {
          air.trace(xmlGuid + ' == ' + dbGuid);
          break;
        } else {
          air.trace(xmlGuid + ' != ' + dbGuid);
          if (j != guidFromDb.length - 1) {
            continue;
          } else {
            air.trace('new xmlGuid: ' + xmlGuid);
            guidIndex.push(i);
          }        
        }
      }    
    }
  } else {
    for (var i = 0; i < guidFromXml.length; i++) {
      guidIndex.push(i);
    }
  }
  
  air.trace('guids from DB count: ' + guidFromDb.length);
  air.trace('new items count: ' + guidIndex.length);
  
  for (var i = 0; i < guidIndex.length; i++) {
    air.trace('guidIndex: ' + guidIndex[i]);
  }
  
  // 4. naplnime pole 'item' tentokrat vsemi polozkami  
  // 5. vlozime nove polozky (volame doInsItem s parametrem = guidIndex[itemIndex], v itemInsertResult na zaklade flagu)
  if (guidIndex.length > 0) {
    updatingItems = true;
    insRowId = refrChannelID;
    itemCount = guidIndex.length;
    doInsItem(guidIndex[itemIndex]);
  } else {
    loader();
  }
}