// odstrani v danem containeru predanou class
function unsetClass (acontainer, aclass) {
  var el = document.querySelector(acontainer + ' .' + aclass);
  if (el) {
    var oldClass = el.getAttribute('class');
    if (oldClass && (oldClass != aclass)) {
      var classes = oldClass.split(' ');
      var newClass = '';
      for (var i = 0; i < classes.length; i++) {
        if (classes[i] != aclass) {
          newClass += classes[i] + ' ';
        }         
      }
      // alert('(' + newOverClass + ')');
      newClass = newClass.substring(0, (newClass.length - 1));
      // alert('(' + newOverClass + ')');
      
    } else {
      newClass = '';
    }
    el.setAttribute('class', newClass);
  }
}


// prida danemu elementu predanou class
function setClass (ael, aclass) {
  var node = ael;     
  if (node.nodeName != 'LI') {
    node = node.parentNode;
  }
  
  var newClass = '';
  var oldClass = node.getAttribute('class');
  if (oldClass && oldClass != aclass) {
    newClass = oldClass + ' ' + aclass;
  } else {
    newClass = aclass;
  }
  node.setAttribute('class', newClass);
}


// nastavi jako aktivni kanal s danym ID
function setActiveOnId (aid) {
  var lis = document.querySelectorAll('#feed-list li');
  
  if (aid != null) {
    for (var i = 0; i < lis.length; i++) {
      var id = lis[i].getAttribute('id');
      if (id == aid) {
        setClass(lis[i], 'active');
        break;
      }
    }
  }
}


// prepinac (zobrazi nebo skryje dany element)
function showHide (aelement) {
  var node = document.querySelector(aelement);
  if (node) {
    var classAttr = node.getAttribute('class');
    if (classAttr && classAttr == 'hdn') {
      node.removeAttribute('class');
    } else {
      node.setAttribute('class', 'hdn');
    }
  }
}


// provede kliknuti na danem elementu v danem kontaineru
function fireClickEvent (acontainer, aelement) {
  var fireOnThis = document.querySelector(acontainer + ' ' + aelement);
  if (fireOnThis) {
    var evObj = document.createEvent('MouseEvents');
    evObj.initEvent('click', true, true);
    fireOnThis.dispatchEvent(evObj);
    air.trace('Event fired');
  }  
}


// nastavi eventListener vsem odkzum v #item-data-list
function bindEvents () {
  var links = document.querySelectorAll('#item-data-list a');

  if (links.length > 0) {
    for (var i = 0; i < links.length; i++) {
      links[i].addEventListener('mouseover', showUrl);
      links[i].addEventListener('mouseout', setDefaultLink);
      links[i].addEventListener('click', openInBrowser, false);
    }
  }
  
  setDefaultLink();
}


// zobrazuje text odkazu (z #item-data-list .title a) v paticce apilikace
function setDefaultLink () {
  var statusBar = document.querySelector('#footer #url');
  var oldEm = document.querySelector('#footer #url em');
  if (oldEm) {
    statusBar.removeChild(oldEm);
  }
  
  var titleLink = document.querySelector('#item-data-list .title a');
  
  if (titleLink.getAttribute('href') != null) {
    var em = document.createElement('em');
    em.innerText = titleLink.getAttribute('href');
    statusBar.appendChild(em);
  }
}


// zobrazuje text odkazu (pri najeti na jakykoliv odkaz v #item-data-list) v paticce apilikace
function showUrl (e) {  
  var statusBar = document.querySelector('#footer #url');
  var oldEm = document.querySelector('#footer #url em');
  if (oldEm) {
    statusBar.removeChild(oldEm);
  }
  
  var link = null;
  var node = e.target;
  while (true) {
    if (node.nodeName == 'A') {
      link = node;
      break;
    } else {
      node = node.parentNode;
      continue;
    }
  }
  
  if (link.getAttribute('href') != null) {
    var em = document.createElement('em');
    em.innerText = link.getAttribute('href');
    statusBar.appendChild(em);
  }  
}


// zarucujuje otevreni kliknuteho odkazu v defaultnim webovem prohlizeci
function openInBrowser (e) {
  // var url = e.target.getAttribute('href');
  // if (url != null) {
  //   var link = new air.URLRequest(url); 
  //   air.navigateToURL(link);
  // }
  var linkNode = document.querySelector('#footer #url em');
  if (linkNode != null) {
    var url = linkNode.firstChild.nodeValue;
    if (url != null) {
      var link = new air.URLRequest(url);
      air.navigateToURL(link);
    }
  }
  
  e.preventDefault();
}


// vraci true, pokud predany elemente obsahuje nejaky nodeType == 1, jinak vraci false
function containHTML (aelement) {
  var children = aelement.childNodes;
  var result = false;
  for (var i = 0; i < children.length; i++) {
    if ((children[i].nodeType == 1) || (children[i].nodeType == 4) || (children[i].nodeType == 5) || (children[i].nodeType == 6)) {
      result = true;
      break;        
    }
  }
  return result;
}


// vynulovani obecneho pole pole (snad ani neni nutne)
function nullArray (aarray) {
  var arrLength = aarray.length;
  for (var i = 0; i < arrLength; i++) {
    aarray.shift();
  }
}


// prevadi predany datovy format na format SQLite
function parseDate (aDate) {
  var date = new Date(aDate);
  var month = ((date.getMonth() + 1) < 10) ? '0' + (date.getMonth() + 1) : (date.getMonth() + 1);
  var dateDay = (date.getDate() < 10) ? '0' + date.getDate() : date.getDate();
  
  var hours = (date.getHours() < 10) ? '0' + date.getHours() : date.getHours();
  var minutes = (date.getMinutes() < 10) ? '0' + date.getMinutes() : date.getMinutes();
  var seconds = (date.getSeconds() < 10) ? '0' + date.getSeconds() : date.getSeconds();
  
  var newDate = date.getFullYear() + '-' + month + '-' + dateDay;
      newDate += ' ' + hours + ':' + minutes + ':' + seconds;
  air.trace(aDate);
  air.trace(date);
  air.trace(newDate);
  return newDate;
}


// indikuje nacitani
function loader () {
  var el = document.querySelector('#footer #loader');
  if (el.getAttribute('class') == null) {
    el.setAttribute('class', 'active');
  } else {
    el.removeAttribute('class');
  }
  air.trace('loader called');
}


// pridani funkci k window.onload udalosti
function addLoadEvent (func) { 
  var oldonload = window.onload; 
  if (typeof window.onload != 'function') { 
    window.onload = func; 
  } else { 
    window.onload = function() { 
      oldonload(); 
      func(); 
    } 
  } 
}